<template lang="pug">
.b-table
	.table-wrapper
		table.table.is-striped.is-hoverable.is-fullwidth
			thead
				tr
					th( v-if='$slots.detail' )
					th( v-for='({ label }, i) in columns' :key='i' ) {{ label }}
			tbody
				template( v-if='data && data.length' )
					template( v-for='(item, y) in data' )
						tr( @click='click(item)' )
							td( v-if='$slots.detail' )
								a.detail-trigger( @click='detailed[y] = !detailed[y]' :class='{ "is-active": detailed[y] }' )
									span.icon
										i.fa-solid.fa-angle-down
							td( 
								v-for='({ field, label }, i) in columns' :key='i'
								:data-label='label')
								template( v-if='$slots[field]' )
									slot( :name='field' :item='item' :index='y' )
								template( v-else ) {{ item[field] }}
						tr.detail( v-if='$slots.detail && detailed[y]' )
							td( :colspan='columns.length + 1' )
								.detail-container: slot( name="detail" :item='item' )
				tr( v-else )
					td.empty( :colspan='columns.length' )
						.is-flex.is-align-items-center.is-justify-content-flex-start
							p
								slot( v-if='$slots.empty' name="empty" )
								template( v-else ) No data
		loading( :active='loading' )
</template>

<script setup>
import { ref } from "vue"

const props = defineProps({
	columns: {
		type: Array,
		default: () => []
	},
	data: {
		type: Array,
		default: () => []
	},
	loading: Boolean
})

const emit = defineEmits([ "click" ])

const detailed = ref({})

const click = item => emit("click", item)
</script>

<style lang="scss" scoped>
@import "node_modules/bulma-responsive-tables/bulma-responsive-tables";
.table-wrapper {
	position: relative;
}

.detail-container {
	padding: .25rem!important;
}

.detail-trigger {
	&:deep(svg) {
		transition: all .2s ease-in-out;
	}
	&.is-active {
		&:deep(svg) {
			transform: rotate(180deg);
		}
	}
}
</style>